Name:		monero
Version:	0.12.0.0
Release:	0.1%{?dist}
Summary:	Monero: the secure, private, untraceable currency

License:	Cryptonote
URL:		https://getmonero.org/
Source0:	https://github.com/monero-project/monero/archive/v%{version}.tar.gz
Patch1:		https://patch-diff.githubusercontent.com/raw/monero-project/monero/pull/3536.patch
#Patch1:		monero-gcc-8-class-memaccess.patch

# FIXME
BuildRequires:  chrpath

BuildRequires:	git cmake doxygen graphviz gtest-devel
BuildRequires:	boost-devel libunwind-devel miniupnpc-devel openssl-devel readline-devel unbound-devel cppzmq-devel
#Requires:	

%description
	Monero: the secure, private, untraceable currency - release version (includes daemon, wallet and miner)

%package tools
Summary:	Additional tools for %{name}

%description tools
%{summary}

%package devel
Summary:        Header files and development libraries for %{name}

%description devel
This package contains the header files and development libraries
for %{name}. If you like to develop programs embedding %{name} on them,
you will need to install %{name}-devel and check %{name}'s API at its
comprisable header file.


%prep
%autosetup -p1
fgrep -rl '${lib_folder}' | xargs sed -i 's/${lib_folder}/${LIB_INSTALL_DIR}/g'
sed -i '/WARNINGS_AS_ERRORS_FLAG/d' CMakeLists.txt


%build
CFLAGS="$(echo ${CFLAGS:-%optflags} | sed -e 's/-Wp,-D_FORTIFY_SOURCE=2//')"
CXXFLAGS="$(echo ${CXXFLAGS:-%optflags} | sed -e 's/-Wp,-D_FORTIFY_SOURCE=2//')"

%cmake	-DBUILD_SHARED_LIBS:BOOL=OFF \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_LINKER=/usr/bin/ld.gold \
	-DARCH=default \
	-DBUILD_TESTS=ON \
	-DBUILD_GUI_DEPS=ON \
	-DNO_AES=ON \
	.

make %{?_smp_mflags}


%check
# Run unit_tests test separately to exclude DNS tests which often fail with
# DNS nameservers configured on some systems
EXCLUDED_UNIT_TESTS+='AddressFromURL.Success'
EXCLUDED_UNIT_TESTS+=':DNSResolver.IPv4Success'
EXCLUDED_UNIT_TESTS+=':DNSResolver.DNSSECFailure'
EXCLUDED_UNIT_TESTS+=':DNSResolver.GetTXTRecord'
EXCLUDED_UNIT_TESTS+=':DNSResolver.IPv4Failure'
EXCLUDED_UNIT_TESTS+=':DNSResolver.DNSSECSuccess'
EXCLUDED_UNIT_TESTS+=':AddressFromURL.Failure'
EXCLUDED_UNIT_TESTS+=':Serialization.portability_wallet'
EXCLUDED_UNIT_TESTS+=':Serialization.portability_outputs'
EXCLUDED_UNIT_TESTS+=':Serialization.portability_unsigned_tx'
EXCLUDED_UNIT_TESTS+=':Serialization.portability_signed_tx'
tests/unit_tests/unit_tests --gtest_filter="-$EXCLUDED_UNIT_TESTS"

# Temporarily disable some a tests:
#  * coretests takes too long (~25000s)
#  * libwallet_api_tests fail (Issue #895)
#  * unit_tests were run separately above
CTEST_ARGS+="-E 'core_tests|libwallet_api_tests|unit_tests'"
echo ">>> NOTE: some tests excluded: $CTEST_ARGS"

make ARGS="$CTEST_ARGS" test


%install
mkdir -p %{buildroot}%{_bindir}

install -Dm755 bin/monero-blockchain-export %{buildroot}%{_bindir}/monero-blockchain-export
install -Dm755 bin/monero-blockchain-import %{buildroot}%{_bindir}/monero-blockchain-import
# Get rid of rpaths
chrpath --delete %{buildroot}%{_bindir}/monero-*

%make_install


%files
%license LICENSE
%{_bindir}/monero-wallet-cli
%{_bindir}/monerod


%files devel
%{_includedir}/wallet/api/wallet2_api.h
%{_libdir}/*.a


%files tools
%{_bindir}/monero-blockchain-export
%{_bindir}/monero-blockchain-import
%{_bindir}/monero-blockchain-blackball
%{_bindir}/monero-blockchain-usage
%{_bindir}/monero-gen-trusted-multisig
%{_bindir}/monero-wallet-rpc



%changelog
* Thu Apr 05 2018 Timothy Redaelli <tredaelli@redhat.com> - 0.12.0.0-0.1
- Backport fix for Ledger Nano S


